###########################################################
#
# Copyright (c) 2005, Southpaw Technology
#                     All Rights Reserved
#
# PROPRIETARY INFORMATION.  This software is proprietary to
# Southpaw Technology, and is not to be reproduced, transmitted,
# or disclosed in any way without written permission.
#
#
#

import sys
import os

import tacticenv
from pyasm.common import Environment

def main(args):

    try:
        update_version_files()

    except Exception, e:
        print 'Error in set_version.py->update_version_files(): ', e.__str__()
        print 'Updating version files failed.  Process terminated.'
        exit()
        
    try:
        run_create_zip()

    except Exception, e:
        print 'Error in set_version.py->run_create_zip(): ', e.__str__()
        print 'Creating zip file failed.  Process terminated.'
        exit()

    print '  ------------------------ set_version completed ------------------------'
    print_file_location_msg()


# Update the 3 version files with the input from the command line.
def update_version_files():    
    env = Environment()
    install_dir = env.get_install_dir()
    pathList = ('','/src/client/tactic_client_lib','/src/pyasm/application/common/interpreter/tactic_client_lib','/src/context')
    pathCount = len(pathList)
    for index, path in enumerate(pathList):
        fullPath = install_dir + path + '/VERSION'
        f = open(fullPath, 'w')
        print '  Output: %i of %i - Writing VERSION to:' % (index+1, pathCount)
        print '                     %s' % fullPath
        # Write the give command line argument as the version string in the file.
        f.write(args[0])
        print '                 - Done.  Closing file.'
        f.close()
        print ''


# Execute the shell script: src/context/client/create_zip.sh
def run_create_zip():
    env = Environment()
    install_dir = env.get_install_dir()
    print install_dir
    os.system('cd ' + install_dir + '/src/context/client; ./create_zip.sh')

def print_file_location_msg():
    env = Environment()
    install_dir = env.get_install_dir()
    print '  The version files are located here:'
    print '    %s/VERSION' % install_dir
    print '    %s/src/context/VERSION' % install_dir
    print '    %s/src/client/tactic_client_lib/VERSION' % install_dir
    print '    %s/src/pyasm/application/common/interpreter/tactic_client_lib/VERSION' % install_dir
    print ''
    print '  The client tactic.zip is located here:'
    print '    %s/src/client/tactic_client_lib/tactic.zip' % install_dir


# Print the usage of the shell command to screen.
def print_usage():
    print 'NAME'
    print '  set_version'
    print ''
    print 'DESCRIPTION'
    print '  Sets the version string inside 3 version files and executes create_zip.sh.'
    print '  The create_zip.sh copies everything in the pyasm/application directory,'
    print '  zips it up, and copies the zipped file to src/client/tactic_client_lib'
    print ''
    print_file_location_msg()
    print ''
    print '  For more details on what set_version.py is automating, please see:'
    print '    http://dev.southpawtech.com/trac/wiki/TACTIC_release_versioning'
    print ''
    print 'EXAMPLE'
    print '  python set_version.py 3.1.0.b01'
    print ''
    return
        

if __name__ == '__main__':
    args = sys.argv[1:]
    if len(sys.argv) > 2:
        print_usage()
        print ''
        print 'error: Only 1 single argument is acceptable.  Please try again.'
        exit()
    if len(sys.argv) < 2:
        print_usage()
        print ''
        print 'error: No arguments found.  Please try again.'
        exit()
    main(args)

