/* *********************************************************
 *
 * Copyright (c) 2005, Southpaw Technology
 *                     All Rights Reserved
 * 
 * PROPRIETARY INFORMATION.  This software is proprietary to
 * Southpaw Technolog, and is not to be reproduced, transmitted,
 * or disclosed in any way without written permission.
 * 
 * 
 */ 


/*
 * Wrapper around the JSCalendar
 */

function TacticCalendar(show_week)
{
    // initialize this global cal
    this.cal = null 
    this.show_week = show_week
    // default close handler
    this.cal_close_handler = function(cal)
    {
        cal.hide()
    }

    this.cal_selected = function(cal, date)
    {
        var element = document.form.elements[cal.hidden_element]
        if (element != null)
          element.value = date

        if (cal.dateClicked)
            cal.callCloseHandler()
    }
    // instantiate the calendar
    this.init = function(input_name)
    {
        var create = false
        if (this.cal == null)
        {
            this.cal = new Calendar(1, null, this.cal_selected, this.cal_close_handler)
            create = true
        }
        this.cal.showsTime = false
        this.cal.weekNumbers = this.show_week
        this.cal.hidden_element = input_name
        var element = document.getElementsByName(input_name)[0] 
        // set input field (probably not needed)
        this.cal.sel = element
        if (create)
            this.cal.create()

    }
    

    this.get_calendar = function()
    {
        return this.cal
    }

    /* input_name: input for the date
       element: the element where the calendar will be positioned 
       date: optional date value */
    this.show_calendar = function(input_name, element, date)
    {
        if (!element)
            element = document.getElementsByName(input_name)[0]
        this.init(input_name)
        
        if (date != null && date != '')
        {
            date_parts = date.split("-")
            year = date_parts[0]
            month = date_parts[1] - 1
            day = date_parts[2]
            this.cal.setDate( new Date(year,month,day) )
        }
        else
            this.cal.setDate( new Date() )
        this.cal.showAtElement(element, 'Br')
        this.cal.dateClicked = false
        
        this.cal.show()

    }

    this.check = function(input_name)
    {
        this.cal.hide()
        var same_cal = (input_name == this.cal.hidden_element)
        if (same_cal && this.cal.dateClicked)
        {
            // VERY IMPORTANT: reset it since this instance is still active
            this.cal.dateClicked = false
            return true
        }
        else
        {
            return false
        }
    }

    
}

TacticCalendarLabel = new function()
{
    this.MONTHS = new Array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul",
        "Aug", "Sep", "Oct", "Nov", "Dec")

    /* update the month/year e.g. 2006:Jan - 2006:Mar range within which the calendar 
       is displayed */
    this.update_range = function(cur_id, other_id, hidden, other_hidden, mode, bound)
    {
        var cur_range = $(cur_id).innerHTML
        var other_range = $(other_id).innerHTML

        var cur_ranges = cur_range.split(':')
        var other_ranges = other_range.split(':')
        

        var year = parseInt(cur_ranges[0])
        var other_year = parseInt(other_ranges[0])
        
        // uses Mootools indexOf
        var month = this.MONTHS.indexOf(cur_ranges[1])
        var other_month = this.MONTHS.indexOf(other_ranges[1])

        month = parseInt(month)
        other_month = parseInt(other_month)

        rtn_data = this._update_range(cur_id, hidden, mode, year, month)
        rtn_year = rtn_data[0]
        rtn_month = rtn_data[1]

        // push the right bound to match the left bound and vice versa
        if ((rtn_month > other_month && rtn_year == other_year 
                && mode=='forward' && bound=='left') ||
                (rtn_year > other_year 
                && mode=='forward' && bound=='left'))
            this._update_range(other_id, other_hidden, mode, year, month)
        else if ((rtn_month < other_month && rtn_year == other_year 
                && mode=='backward' && bound=='right') ||
                (rtn_year < other_year 
                && mode=='backward' && bound=='right'))
            this._update_range(other_id, other_hidden, mode, year, month)
            
        
    }

    this._update_range = function(cur_id, hidden, mode, year, month)
    {
        if (mode == 'forward')
        {
            month += 1
            if (month > 11)
            {
                year += 1
                month = 0
            }
        }
        else
        {
            month -= 1
            if (month < 0)
            {
                year -= 1
                month = 11
            }
        }
        var date_value = year + ":" + this.MONTHS[month]
        $(cur_id).innerHTML = date_value
            
        get_elements(hidden).set_value(date_value)

        rtn = new Array(year, month)
        return rtn
    }

    /* Realign the divider lines and match the length to the height of table */
    this.realign = function(src_name, target_div_id, target_table_id, y_offset)
    {
        var target = document.getElementById(target_div_id)
        var x_pos = Common.find_pos_x(target)
        var srcs = $$('div.' + src_name)
        for (var i = 0; i < srcs.length; i++)
        {
            var src_elem = srcs[i]
            var cur_pos_x = Common.find_pos_x(src_elem)
            var offset = 1
            src_elem.style.left = cur_pos_x + x_pos - offset
            this.match_height(target_table_id, src_elem, y_offset)
        }

    }

    /* match the height of the src_elem to the ref element */
    this.match_height = function(ref_elem_id, src_elem, y_offset)
    {
        //alert(src_elem_id + "  " + target_elem_id + "  " +offset)
        var ref_elem = document.getElementById(ref_elem_id)
        if (src_elem != null)
            src_elem.style.height = ref_elem.offsetHeight - y_offset
    }

    /* set the range of the calendar plus the week if specified */
    this.set_range = function(cur_id, value)
    {
        var val= value.split(':')
        // make sure it is a valid month 
        if (this.MONTHS.indexOf(val[1]) > -1)
            get_elements(cur_id).set_value(val[0] + ':' + val[1])
        if (val[2]) // if a week is given
        {
            var week = val[2]
            get_elements('cal_week_hid').set_value(week)
        }

    }
}







