###########################################################
#
# Copyright (c) 2005, Southpaw Technology
#                     All Rights Reserved
#
# PROPRIETARY INFORMATION.  This software is proprietary to
# Southpaw Technology, and is not to be reproduced, transmitted,
# or disclosed in any way without written permission.
#
#
#

__all__ = ['FlashUpgrade']


from pyasm.search.upgrade.project import *


class FlashUpgrade(BaseUpgrade):



    # remove NOT NULL constraint on asset code and switch primary key to id
    def upgrade_v2_5_0_a01_020(my):
        my.run_sql('''
        ALTER TABLE asset ALTER COLUMN name DROP NOT NULL;
        ''')



    def upgrade_v2_5_0_a01_019(my):
        my.run_sql('''
        ALTER TABLE asset ALTER COLUMN code DROP NOT NULL;
        ''')


    def upgrade_v2_5_0_a01_018(my):
        my.run_sql('''
        alter table asset add primary key (id);
        ''')

    def upgrade_v2_5_0_a01_017(my):
        my.run_sql('''
        alter table asset drop constraint asset_pkey;
        ''')

    def upgrade_v2_5_0_a01_016(my):
        my.run_sql('''
        alter table texture drop constraint "$1";
        ''')


    def upgrade_v2_5_0_a01_016(my):
        my.run_sql('''
        alter table layer_instance drop constraint "$2";
        ''')


    def upgrade_v2_5_0_a01_015(my):
        my.run_sql('''
        alter table instance drop constraint asset_code_fkey;
        ''')

    def upgrade_v2_5_0_a01_014(my):
        my.run_sql('''
        alter table texture_source drop constraint texture_source_asset_code_fkey;
        ''')


    # drop the not null constraint on asset type
    def upgrade_v2_5_0_a01_013(my):
        my.run_sql('''
        ALTER TABLE asset ALTER COLUMN asset_type DROP NOT NULL;
        ''')


    def upgrade_v2_5_0_a01_012(my):
        my.run_sql('''
        ALTER TABLE asset ALTER COLUMN code DROP NOT NULL;
        ''')


    def upgrade_v2_5_0_a01_012(my):
        my.run_sql('''
        alter table asset drop constraint asset_pkey;
        ''')
 


    def upgrade_v2_5_0_a01_011(my):
        my.run_sql('''
        ALTER TABLE shot ALTER COLUMN code DROP NOT NULL;
        ''')


    def upgrade_v2_5_0_a01_010(my):
        my.run_sql('''
        alter table shot add primary key (id);
        ''')

    def upgrade_v2_5_0_a01_009(my):
        my.run_sql('''
        alter table shot drop constraint scene_pkey;
        ''')

    def upgrade_v2_5_0_a01_008(my):
        #"shot_code_fkey" FOREIGN KEY (shot_code) REFERENCES shot(code) ON UPDATE CASCADE ON DELETE RESTRICT DEFERRABLE INITIALLY DEFERRED

        my.run_sql('''
        alter table shot_audio drop constraint shot_code_fkey;
        ''')


    def upgrade_v2_5_0_a01_007(my):
        #"shot_code_fkey" FOREIGN KEY (shot_code) REFERENCES shot(code) ON UPDATE CASCADE ON DELETE RESTRICT DEFERRABLE INITIALLY DEFERRED

        my.run_sql('''
        alter table storyboard drop constraint shot_code_fkey;
        ''')

    def upgrade_v2_5_0_a01_006(my):
        #"shot_code_fkey" FOREIGN KEY (shot_code) REFERENCES shot(code) ON UPDATE CASCADE ON DELETE RESTRICT DEFERRABLE INITIALLY DEFERRED

        my.run_sql('''
        alter table instance drop constraint shot_code_fkey;
        ''')


    def upgrade_v2_5_0_a01_005(my):
        #"shot_code_fkey" FOREIGN KEY (shot_code) REFERENCES shot(code) ON UPDATE CASCADE ON DELETE RESTRICT DEFERRABLE INITIALLY DEFERRED

        my.run_sql('''
        alter table layer drop constraint shot_code_fkey;
        ''')




    def upgrade_v2_5_0_a01_003(my):
        my.run_sql('''
        ALTER TABLE shot ALTER COLUMN episode_code DROP NOT NULL;
        ''')



    def upgrade_v1_9_1_a02_002(my):
        my.run_sql('''ALTER TABLE episode add column sort_order integer;''')
        my.run_sql('''ALTER TABLE episode drop column title;''')
        my.run_sql('''alter table render alter column snapshot_code drop not null;''')

    def upgrade_v1_9_0_a1_003(my):
        my.run_sql('''
        INSERT INTO prod_setting ("category", "key", value, description, "type", search_type) VALUES ('Naming', 'use_name_as_asset_code', 'false', 'Use name as the asset code', 'sequence', NULL);
        ''')


    def upgrade_v1_9_0_a1_002(my):
        my.run_sql('''
        update prod_setting set category = 'General' where category is NULL;
        ''')

    def upgrade_v1_9_0_a1_001(my):
        my.run_sql('''
        ALTER TABLE prod_setting ADD COLUMN category varchar(256);
        ''')

    def upgrade_v1_6_0_b2_001(my):
        my.run_sql('''
        CREATE TABLE episode_instance (
            id serial NOT NULL,
            episode_code character varying(30) NOT NULL,
            asset_code character varying(100) NOT NULL,
            "timestamp" timestamp without time zone DEFAULT now(),
            status text,
            "type" character varying(30)
        );
        ''')


    def upgrade_20070927(my):
        my.run_sql('''
        ALTER TABLE pickup_request add column description text;
        ''')

    def upgrade_20070926(my):
        my.run_sql('''
        ALTER TABLE nat_pause add CONSTRAINT nat_pause_episode_code_key UNIQUE (episode_code);
        ''')

    def upgrade_20070925(my):
        my.run_sql('''
        CREATE TABLE pickup_request (
            id serial NOT NULL,
            episode_code character varying(30),
            status character varying(100),
            PRIMARY KEY (id),
            CONSTRAINT episode_code_fkey FOREIGN KEY (episode_code)
              REFERENCES episode (code) 
              ON UPDATE CASCADE ON DELETE RESTRICT DEFERRABLE INITIALLY DEFERRED,
            CONSTRAINT pickup_request_episode_code_key UNIQUE (episode_code)
        );
        ''')

    def upgrade_20070924(my):
        my.run_sql('''
        CREATE TABLE final_wave (
            id serial NOT NULL,
            title character varying(30),
            episode_code character varying(30),
            line integer,
            PRIMARY KEY (id),
            CONSTRAINT episode_code_fkey FOREIGN KEY (episode_code)
              REFERENCES episode (code) 
              ON UPDATE CASCADE ON DELETE RESTRICT DEFERRABLE INITIALLY DEFERRED,
            CONSTRAINT episode_code_line_key UNIQUE (episode_code, line)
        );
        ''')
        

    def upgrade_20070912(my):
        my.run_sql('''
        CREATE TABLE shot_audio (
            id serial NOT NULL,
            title character varying(30),
            shot_code character varying(100),
            PRIMARY KEY (id),
            CONSTRAINT shot_code_fkey FOREIGN KEY (shot_code)
              REFERENCES shot (code) 
              ON UPDATE CASCADE ON DELETE RESTRICT DEFERRABLE INITIALLY DEFERRED
        );
        ''')

    def upgrade_20070903(my):
        my.run_sql('''
        ALTER TABLE episode RENAME retire_status TO s_status;
        '''
        )

    def upgrade_20070824(my):
        my.run_sql('''
        ALTER TABLE shot RENAME pipeline TO pipeline_code;
        ALTER TABLE asset RENAME pipeline TO pipeline_code;
        ''')


    def upgrade_20070718(my):
        my.run_sql('''
        CREATE TABLE naming (
            id serial PRIMARY KEY,
            search_type varchar(100),
            dir_naming text,
            file_naming text
        );
        ''')


    def upgrade_20070615(my):
        my.run_sql('''
        ALTER TABLE submission ADD COLUMN status varchar(100);
        ''')

    def upgrade_20070613(my):
        my.run_sql('''
	CREATE INDEX shot_code_idx ON shot USING btree (code);
	CREATE INDEX shot_episode_code_idx ON shot USING btree (episode_code);
	CREATE INDEX shot_id_idx ON shot USING btree (id);
	CREATE INDEX shot_s_status_idx ON shot USING btree (s_status);
        ''')



    def upgrade_20070426(my):
        my.run_sql('''
CREATE TABLE leica (
    id serial NOT NULL,
    code character varying(256),
    snapshot text,
    episode_code character varying(30) NOT NULL,
    "timestamp" timestamp without time zone DEFAULT now(),
    shot_code character varying(30),
    description text
);
        ''')




    def upgrade_20070426(my):
        my.run_sql('''
        ALTER TABLE layer ADD CONSTRAINT shot_code_fkey FOREIGN KEY (shot_code) REFERENCES shot(code) ON UPDATE CASCADE  ON DELETE RESTRICT DEFERRABLE INITIALLY DEFERRED;
        ''')


    def upgrade_20070320(my):
        my.run_sql('''
        alter table submission add column artist varchar(256);
        ''')

    def upgrade_20070319(my):
        my.run_sql('''
        CREATE TABLE nat_pause (
            id serial NOT NULL,
            title character varying(30),
            episode_code character varying(30),
            PRIMARY KEY (id)
        );
        ''')

    def upgrade_20070315(my):
        my.run_sql('''
        ALTER TABLE script RENAME COLUMN artist TO author;
        ALTER TABLE script ADD COLUMN stage varchar(256);
        ALTER TABLE script ADD COLUMN title text;
        ''')

    def upgrade_20070129(my):
        my.run_sql('''
        ALTER TABLE storyboard ADD CONSTRAINT shot_code_fkey FOREIGN KEY (shot_code) REFERENCES shot(code) ON UPDATE CASCADE  ON DELETE RESTRICT DEFERRABLE INITIALLY DEFERRED;

        ALTER TABLE instance DROP constraint "$1";
        ALTER TABLE instance DROP constraint "$2";
        ALTER TABLE instance ADD CONSTRAINT asset_code_fkey FOREIGN KEY (asset_code) REFERENCES asset(code) ON UPDATE CASCADE  ON DELETE RESTRICT DEFERRABLE INITIALLY DEFERRED;
        ALTER TABLE instance ADD CONSTRAINT shot_code_fkey FOREIGN KEY (shot_code) REFERENCES shot(code) ON UPDATE CASCADE  ON DELETE RESTRICT DEFERRABLE INITIALLY DEFERRED;
        ''')

    def upgrade_20070126(my):
        my.run_sql('''
        alter table bin add column label varchar(100);
        ''')

    def upgrade_20070123(my):
        my.run_sql('''
        alter table shot add column sort_order int2;
        ''')

    def upgrade_20070119(my):
        my.run_sql('''
        CREATE TABLE prod_setting (
            id serial NOT NULL,
            "key" character varying(100),
            value text,
            description text,
            "type" character varying(30),
            search_type character varying(200)
        );
        ''')


    def upgrade_20061213(my):
        my.run_sql('''
        alter table storyboard add column code varchar(30);
        alter table storyboard add column shot_code varchar(30);
        alter table storyboard add column description text;
        ''')


    def upgrade_20061207(my):
        my.run_sql('''
         -- add a submission table for editorial purpose
        CREATE TABLE submission (
            id serial PRIMARY KEY,
            search_type varchar(200),
            search_id int4,
            snapshot_code varchar(30),
            context varchar(100),
            version int4,
            description text,
            login varchar(30),
            timestamp timestamp default now(),
            s_status varchar(30)
        );

        CREATE TABLE bin (
            id serial PRIMARY KEY,
            code varchar(256),
            description text,
            type varchar(100),
            s_status varchar(30)
        );

        CREATE TABLE submission_in_bin
        (
          id serial PRIMARY KEY,
          submission_id int4 NOT NULL,
          bin_id int4 NOT NULL,
          CONSTRAINT submission_in_bin_bin_id_fkey FOREIGN KEY (bin_id)
              REFERENCES bin (id) 
              ON UPDATE CASCADE ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED,
          CONSTRAINT submission_in_bin_submission_id_fkey FOREIGN KEY (submission_id)
              REFERENCES submission (id) 
              ON UPDATE CASCADE ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED
        ); 
        alter table submission_in_bin add constraint submission_id_bin_id_key 
            UNIQUE (submission_id, bin_id);    
        
        ''')


    def upgrade_20061122(my):
        my.run_sql('''
        -- add ability to retire assets and layers
        alter table asset add column s_status varchar(30);
        alter table layer add column s_status varchar(30);
        alter table shot add column s_status varchar(30);

        -- add a complexity to a shot
        alter table shot add column complexity int2;

        -- add asset_type constraint
        ALTER TABLE ONLY asset_type ADD CONSTRAINT asset_type_pkey PRIMARY KEY (code);
        ''')
    


