###########################################################
#
# Copyright (c) 2005, Southpaw Technology
#                     All Rights Reserved
#
# PROPRIETARY INFORMATION.  This software is proprietary to
# Southpaw Technology, and is not to be reproduced, transmitted,
# or disclosed in any way without written permission.
#
#
#


__all__ = ['ChartWdg']

from pyasm.common import Environment, Common, jsonloads
from pyasm.biz import Project
from pyasm.web import Widget, DivWdg, HtmlElement, WebContainer
from pyasm.widget import SelectWdg, TextWdg
from pyasm.search import Search, SearchType
from tactic.ui.common import BaseRefreshWdg

import types


class ChartWdg(BaseRefreshWdg):

    ARGS_KEYS = {
        'chart': 'chart object to display',
        'data_file':  'file name to use for data',
        'width': 'width of the chart'

    }

    def get_display(my):

        chart_data = my.kwargs.get('chart')
        data_file = my.kwargs.get('data_file')
        width = my.kwargs.get('width')
        if not width:
            width = '100%'

        if chart_data:
            if type(chart_data) in types.StringTypes:
                data = jsonloads(chart_data)
            elif type(chart_data) == types.DictType:
                data = chart_data
            else:
                data = chart_data.get_data()

            file = '__NONE__'

        else:
            data = {}
            if data_file:
                file = data_file
            else:
                file = '__NONE__'
             
        top = DivWdg()

        inner = DivWdg()
        top.add(inner)


        # the element that gets replaced
        div = DivWdg()
        inner.add(div)
        inner.add_color("background", "background")
        inner.add_style("padding: 15px")


        import random
        number = random.randint(0, 1000000)
        chart_id = 'my_chart%s' % number
        div.set_id(chart_id)

        top.add_behavior({
            'type': 'load',
            'data': data,
            'file': file,
            'chart_id': chart_id,
            'cbjs_action': '''

            var flashvars;
            if (bvr.file != '__NONE__') {
                flashvars = {
                    "data-file":    '/context/spt_js/ofc/data-files/'+bvr.file
                };
            }
            else {
                flashvars = null;

                open_flash_chart_data = function() {
                    return JSON.stringify(bvr.data);
                }
            }

            var params = {
                wmode:      'transparent'
            };


            var ofc_url = "/context/spt_js/ofc/open-flash-chart.swf";
            var attrs = {};
            var width = "%s";
            var height = "300";

            swfobject.embedSWF(ofc_url, bvr.chart_id, width, height, "9.0.0", "expressInstall.swf", flashvars, params, attrs);

            window.addEvent('domready', function(){
                    $(bvr.chart_id).makeResizable();
            });


            ''' % width
        })


        top.add("<br clear='all'/>")

        return top


