###########################################################
#
# Copyright (c) 2005, Southpaw Technology
#                     All Rights Reserved
#
# PROPRIETARY INFORMATION.  This software is proprietary to
# Southpaw Technology, and is not to be reproduced, transmitted,
# or disclosed in any way without written permission.
#
#
#


__all__ = ['ButtonRowWdg', 'ButtonNewWdg', 'ActionButtonWdg', 'IconButtonWdg', 'IconButtonElementWdg', 'SingleButtonWdg']


from pyasm.search import Search, SObjectConfig, SearchType, SObjectFactory
from pyasm.web import HtmlElement, SpanWdg, DivWdg, Table, WebContainer
from pyasm.widget import IconWdg

from tactic.ui.common import BaseRefreshWdg

BASE = '/context/themes2'
ALPHA = "1.0"

class ButtonRowWdg(BaseRefreshWdg):

    def init(my):
        my.top = DivWdg()

    def add_style(my, name, value=None):
        my.top.add_style(name, value)

    def get_num_buttons(my):
        return len(my.widgets)

    def get_display(my):

        top = my.top

        buttons = []

        show_title = my.kwargs.get("show_title")
        show_title = show_title in ['True', True]

        for button in my.widgets:
            if isinstance(button, ButtonNewWdg):
                button.set_show_title(show_title)
            buttons.append(button)

        top.add( my.get_row_wdg(buttons, show_title=show_title) )
        #top.add( my.get_row_wdgXX(buttons, show_title=show_title) )
        return top

        #top = DivWdg()

        button_div = DivWdg()
        top.add(button_div)
        button_div.add("<img src='/context/test/buttons.png'/>")
        button_div.add_style("margin-top: -2px")
        button_div.add_style("float: left")

        button_div = DivWdg()
        button_div.add_style("float: left")
        top.add(button_div)
        from pyasm.web import HtmlElement
        button1 = HtmlElement.img(src='/context/test/button_s1.png')
        button_div.add(button1)
        button.add_style("display: block")
        button1.add_class("spt_button")

        button1.add_behavior( {
        'type': 'hover',
        'cbjs_action_over': '''
            bvr.src_el.src = '/context/test/button_s2.png';
        ''',
        'cbjs_action_out': '''
            bvr.src_el.src = '/context/test/button_s1.png';
        '''
        } )
        button1.add_behavior( {
        'type': 'click',
        'cbjs_action': '''
            bvr.src_el.src = '/context/test/button_s3.png';
        '''
        } )
        button1.add_behavior( {
        'type': 'click_up',
        'cbjs_action': '''
            bvr.src_el.src = '/context/test/button_s2.png';
        '''
        } )


        return top



    def get_row_wdg(my, buttons, show_title=False):

        table = Table()
        table.add_style("margin-top: -3px")
        table.add_attr("cellspacing", "0px")
        table.add_attr("cellpadding", "0px")
        table.add_row()

        base = "%s/%s" % (BASE, my.top.get_theme() )

        img = "<img src='%s/MainButtonSlices_left.png'/>" % base
        left = DivWdg(img)
        left.add_style("opacity", ALPHA)
        table.add_cell(left)

        td = table.add_cell()
        td.add_style("border-size: 0")
        for count, button in enumerate(buttons):
            button.add_style("float: left")
            td.add(button)

            if button.get_show_arrow_menu():
                spacer = DivWdg()
                spacer.add_style("float: left")
                td.add(spacer)
                img = "<img src='%s/MainButtonSlices_between.png'/>" % base
                spacer.add(img)
                spacer.add_style("opacity", ALPHA)



            if count < len(buttons)-1:
                spacer = DivWdg()
                spacer.add_style("float: left")
                td.add(spacer)
                img = "<img src='%s/MainButtonSlices_between.png'/>" % base
                spacer.add(img)
                spacer.add_style("opacity", ALPHA)


        img = "<img src='%s/MainButtonSlices_right.png'/>" % base
        right = DivWdg(img)
        right.add_style("opacity", ALPHA)
        table.add_cell(right)

        return table




    def get_row_wdgXX(my, buttons, show_title=False):

        top = DivWdg()
        #top.add_style("-moz-transform: scale(1.0)")
        top.add_style("float: left")
        top.add_style("margin-left: 3px")
        top.add_style("margin-right: 3px")

        if show_title:
            top.add_style("height: 29px")
        else:
            top.add_style("height: 23px")
        top.add_style("height: 33px")

        left = DivWdg()
        left.add_style("-moz-border-radius-topleft: 20px")
        left.add_style("-moz-border-radius-bottomleft: 20px")
        left.add_border()
        left.add_gradient("background", "background", 20, -35)
        #left.add_style("background: black")
        left.add_style("float: left")
        left.add_style("height: 100%")
        left.add_style("width: 5px")
        left.add_style("z-index: 0")
        left.add_style("margin-right: -1")
        top.add(left)

        for button in buttons:
            button.add_style("float: left")
            top.add(button)


        right = DivWdg()
        right.add_style("-moz-border-radius-topright: 20px")
        right.add_style("-moz-border-radius-bottomright: 20px")
        right.add_gradient("background", "background", 20, -35)
        #right.add_style("background: black")
        right.add_style("float: left")
        right.add_style("height: 100%")
        right.add_style("width: 5px")
        #right.add_style("margin-left: -1px")
        right.add_style("z-index: 0")
        right.add_style("border-style: solid")
        right.add_style("border-color: %s" % right.get_color("border") )
        right.add_style("border-width: 1 1 1 0")
        top.add(right)


        return top


class ButtonNewWdg(BaseRefreshWdg):

    def get_args_keys(my):
        return {
        'title': 'The title of the button',
        'show_menu': 'True|False - determines whether or not to show the menu',
        'show_title': 'True|False - determines whether or not to show the title',
        }

    def init(my):
        #my.inner = DivWdg()
        my.dialog = None
        my.button = DivWdg()
        my.hit_wdg = DivWdg()
        my.arrow_div = DivWdg()
        my.arrow_menu = IconButtonWdg(title="More Options", icon=IconWdg.ARROWHEAD_DARK_DOWN)

        my.show_arrow_menu = False
        # for icon decoration
        my.icon_div = DivWdg()

        my.is_disabled = my.kwargs.get("is_disabled") in [True,"true"]


    def add_style(my, name, value=None):
        my.top.add_style(name, value)

    def add_behavior(my, behavior):
        my.hit_wdg.add_behavior(behavior)

    def add_class(my, class_name):
        my.hit_wdg.add_class(class_name)

    def set_attr(my, attr, name):
        my.hit_wdg.set_attr(attr, name)


    

    def add_arrow_behavior(my, behavior):
        my.arrow_menu.add_behavior(behavior)
        my.show_arrow_menu = True

    def set_show_arrow_menu(my, flag):
        my.show_arrow_menu = flag

    def get_arrow_wdg(my):
        return my.arrow_menu

    def get_show_arrow_menu(my):
        return my.show_arrow_menu

    def set_show_title(my, flag):
        my.kwargs['show_title' ] = flag

    def add_dialog(my, dialog):
        my.dialog = dialog


    def get_button_wdg(my):
        return my.hit_wdg

    def get_icon_wdg(my):
        return my.icon_div


    def get_display(my):

        top = my.top
        top.add_style("white-space: nowrap")
        #top.add_style("position: relative")

        base = "%s/%s" % (BASE, my.top.get_theme() )


        show_menu = my.kwargs.get("show_menu")
        is_disabled = my.kwargs.get("is_disabled")

        button = DivWdg()
        button.add_style("float: left")
        
        my.inner = button
        top.add(button)

        button.add_class("spt_button_top")
        button.add_style("position: relative")

        img = "<img src='%s/MainButtonSlices_button.png'/>" % base
        img_div = DivWdg(img)
        button.add(img_div)
        img_div.add_style("opacity", ALPHA)
       
       

        over_div = DivWdg()
        button.add(over_div)
        over_div.add_class("spt_button_over")
        over_img = "<img src='%s/MainButton_over.png'/>" % base
        over_div.add(over_img)
        over_div.add_style("position: absolute")
        over_div.add_style("top: 0px")
        over_div.add_style("left: 0px")
        over_div.add_style("display: none")

        click_div = DivWdg()
    
        button.add(click_div)
        click_div.add_class("spt_button_click")
        click_img = "<img src='%s/MainButton_click.png'/>" % base
        click_div.add(click_img)
        click_div.add_style("position: absolute")
        click_div.add_style("top: 0px")
        click_div.add_style("left: 0px")
        click_div.add_style("display: none")


        title = my.kwargs.get("title")
        

        icon_div = my.icon_div
        button.add(icon_div)
        #icon_div.add_class("spt_button_click")
        icon_str = my.kwargs.get("icon")
        icon = IconWdg(title, icon_str, right_margin=0)
        icon.add_class("spt_button_icon")
        icon_div.add(icon)
        icon_div.add_style("position: absolute")
        icon_div.add_style("top: 12px")
        icon_div.add_style("left: 6px")

        if my.is_disabled:
            icon_div.add_style("opacity: 0.5")
        

        my.icon_div = icon_div
        
       

        my.show_arrow = my.kwargs.get("show_arrow") in [True, 'true']
        if my.show_arrow or my.dialog:
            arrow_div = DivWdg()
            button.add(arrow_div)
            arrow_div.add_style("position: absolute")
            arrow_div.add_style("top: 24px")
            arrow_div.add_style("left: 20px")

            arrow = IconWdg(title, IconWdg.ARROW_MORE_INFO)
            arrow_div.add(arrow)


        web = WebContainer.get_web()
        is_IE = web.is_IE()

        #my.hit_wdg.add_style("height: 100%")
        my.hit_wdg.add_style("width: 100%")
        if is_IE:
            my.hit_wdg.add_style("filter: alpha(opacity=0)")
            my.hit_wdg.add_style("height: 40px")
        else:
            my.hit_wdg.add_style("height: 100%")
            my.hit_wdg.add_style("opacity: 0.0")

        if my.is_disabled:
            my.hit_wdg.add_style("display: none")

        button.add(my.hit_wdg)


        my.hit_wdg.add_style("position: absolute")
        my.hit_wdg.add_style("top: 0px")
        my.hit_wdg.add_style("left: 0px")
        #my.hit_wdg.add_style("background: #FFF")
        my.hit_wdg.add_attr("title", title)
        #my.hit_wdg.add_style("display: none")
        #my.hit_wdg.add_styles('''filter: alpha(opacity=0); -moz-opacity: 0; opacity: 0''')
        my.hit_wdg.add_behavior( {
        'type': 'hover',
        'cbjs_action_over': '''
            var top = bvr.src_el.getParent(".spt_button_top")
            var over = top.getElement(".spt_button_over");
            var click = top.getElement(".spt_button_click");
            over.setStyle("display", "");
            click.setStyle("display", "none");
        ''',
        'cbjs_action_out': '''
            var top = bvr.src_el.getParent(".spt_button_top")
            var over = top.getElement(".spt_button_over");
            var click = top.getElement(".spt_button_click");
            over.setStyle("display", "none");
            click.setStyle("display", "none");
        '''
        } )
        
        my.hit_wdg.add_behavior( {
        'type': 'click',
        'cbjs_action': '''
            var top = bvr.src_el.getParent(".spt_button_top")
            var over = top.getElement(".spt_button_over");
            var click = top.getElement(".spt_button_click");
            over.setStyle("display", "none");
            click.setStyle("display", "");
        '''
        } )
        my.hit_wdg.add_behavior( {
        'type': 'click_up',
        'cbjs_action': '''
            var top = bvr.src_el.getParent(".spt_button_top")
            var over = top.getElement(".spt_button_over");
            var click = top.getElement(".spt_button_click");
            over.setStyle("display", "");
            click.setStyle("display", "none");
        '''
        } )



        # add a second arrow widget
        if my.show_arrow_menu:
            my.inner.add(my.arrow_div)
            my.arrow_div.add_attr("title", "More Options")
            my.arrow_div.add_style("position: absolute")
            my.arrow_div.add_style("top: 11px")
            my.arrow_div.add_style("left: 20px")
            my.arrow_div.add(my.arrow_menu)






        if my.dialog:
            top.add(my.dialog)
            dialog_id = my.dialog.get_id()
            my.hit_wdg.add_behavior( {
            'type': 'click_up',
            'dialog_id': dialog_id,
            'cbjs_action': '''
            var dialog = $(bvr.dialog_id);
            var pos = bvr.src_el.getPosition();
            var size = bvr.src_el.getSize();
            //var dialog = $(bvr.dialog_id);
            dialog.setStyle("left", pos.x);
            dialog.setStyle("top", pos.y+size.y);
            spt.toggle_show_hide(dialog);

            '''
            } )




        return top




    def get_displayxx(my):

        show_menu = my.kwargs.get("show_menu")
        is_disabled = my.kwargs.get("is_disabled")

        show_title = my.kwargs.get("show_title")
        show_title = show_title in ['True', True]

        width = 35 
        if show_title:
            height = 26
        else:
            height = 20
        height = 30

        top = my.top
        top.add_class("spt_button_top")
        top.add_style("overflow: hidden")


        #border = top.get_color("border")
        #top.add_border(-20)
        top.add_gradient("background", "background", 20, -35)
        top.add_style("border-width: 1px 0 1px 0")
        top.add_style("border-style: solid")
        top.add_style("border-color: %s" % top.get_color('border'))
        #top.add_style("margin-left: -1px")

        inner = my.inner
        top.add(inner)
        inner.add_color("color", "color3")
        inner.add_style("padding-top: 3px")
        inner.add_style("overflow: hidden")

        title = my.kwargs.get("title")

        inner.add_class("hand")
        inner.add_style("z-index: 20")
        #inner.add_style("overflow: hidden")
        #inner.add_style("opacity: 0.5")
        inner.add_attr("title", title)

        my.button.add_style("margin-top: 5px")
        inner.add(my.button)
        icon_str = my.kwargs.get("icon")
        icon = IconWdg(title, icon_str)
        my.button.add(icon)
        icon.add_class("spt_button_icon")

        my.show_arrow = my.kwargs.get("show_arrow") in [True, 'true']
        if my.show_arrow or my.dialog:
            arrow = IconWdg(title, IconWdg.ARROW_MORE_INFO)
            inner.add(arrow)
            arrow.add_style("position: absolute")
            arrow.add_style("float: left")
            arrow.add_style("margin-left: 2px")
            arrow.add_style("margin-top: -10px")




        inner.add_style("font-size: 8px")
        inner.add_style("height: %spx" % height)
        inner.add_style("width: %spx" % width)
        inner.add_style("text-align: center")

        show_title = False
        if show_title:
            title_div = DivWdg()
            title_div.add(title)
            inner.add(title_div)



        inner.add_behavior( {
        'type': 'click',
        'width': width,
        'cbjs_action': '''
            var button = bvr.src_el;
            button.setStyle("border-style", "ridge");
            button.setStyle("width", bvr.width-2);
        '''
        } )


        inner.add_behavior( {
        'type': 'click_up',
        'width': width,
        'cbjs_action': '''
            var button = bvr.src_el;
            button.setStyle("border-style", "none");
            button.setStyle("width", bvr.width);
        '''
        } )


        inner.add_behavior( {
        'type': 'hover',
        'width': width,
        'cbjs_action_over': '''
            var button = bvr.src_el;
            var icon = button.getElement(".spt_button_icon");
            icon.setStyle('opacity', '1');
        ''',
        'cbjs_action_out': '''
            var button = bvr.src_el;
            button.setStyle("border-style", "none");
            var icon = button.getElement(".spt_button_icon");
            icon.setStyle('opacity', '0.5');

            button.setStyle("width", bvr.width);

        '''
 
        } )


        if show_menu in ['true', True]:
            inner.add_style("float: left")
            arrow_div = DivWdg()
            top.add(arrow_div)
            arrow_div.add_style("opacity: 0.5")
            arrow_div.add_style("z-index: 100")
            arrow_div.add_style("height: %spx" % height)
            arrow_div.add_style("border-left: dotted 1px %s" % arrow_div.get_color("border") )
            #arrow_div.add_style("margin-left: -15px")
            arrow_div.add_style("float: left")

            arrow = DivWdg(IconWdg("More Options", IconWdg.ARROW_MORE_INFO))
            arrow.add_style("margin-top: 8px")
            arrow_div.add(arrow)
            arrow_div.add_style("position: relative")


            arrow_div.add_behavior( {
            'type': 'hover',
            'cbjs_action_over': '''
                var button = bvr.src_el;
                var height = parseInt(button.getStyle("height").replace("px",""));
                var width = parseInt(button.getStyle("width").replace("px",""));
                button.setStyle('opacity', '1');
                button.setStyle('border', 'solid 1px red');
                button.setStyle("height", height-2);
                button.setStyle("width", width-2);
            ''',
            'cbjs_action_out': '''
                var button = bvr.src_el;

                var height = parseInt(button.getStyle("height").replace("px",""));
                var width = parseInt(button.getStyle("width").replace("px",""));

                button.setStyle('opacity', '0.5');
                button.setStyle('border', '');
                button.setStyle("height", height+2);
                button.setStyle("width", width+2);
            '''
     
            } )

            my.add_menu_wdg(arrow_div)



        if is_disabled in ['true', True]:
            disabled_div = DivWdg()
            disabled_div.add_class("spt_save_button_disabled")
            disabled_div.set_attr("title", "%s (Disabled)" % title)
            disabled_div.add_style("position: relative")
            disabled_div.add_style("height: %spx" % (height+3))
            disabled_div.add_style("width: %spx" % width)
            #disabled_div.add_style("margin-left: -%spx" % width)
            disabled_div.add_style("margin-top: -%spx" % (height+3))
            disabled_div.add_style("opacity", "0.6")
            disabled_div.add_style("background", "#AAA")
            inner.add_style("opacity", "1")
            top.add(disabled_div)



        if my.dialog:
            top.add(my.dialog)
            dialog_id = my.dialog.get_id()
            inner.add_behavior( {
            'type': 'load',
            'height': height,
            'dialog_id': dialog_id,
            'cbjs_action': '''
            var pos = bvr.src_el.getPosition();
            var el = $(bvr.dialog_id);
            el.setStyle("left", pos.x);
            el.setStyle("top", pos.y+bvr.height+13);
            '''
            } )

            my.inner.add_behavior( {
            'type': 'click_up',
            'dialog_id': dialog_id,
            'cbjs_action': '''
            var dialog = $(bvr.dialog_id);
            spt.toggle_show_hide(dialog);
            '''
            } )


        return top



    def add_menu_wdg(my, button, menus):

        from tactic.ui.container import SmartMenu

        my.menus = []
        my.menus.append(menu.get_data())

        smenu_set = SmartMenu.add_smart_menu_set( button, { 'BUTTON_MENU': my.menus } )
        SmartMenu.assign_as_local_activator( button, "BUTTON_MENU", True )
 


class ActionButtonWdg(DivWdg):


    ARGS_KEYS = {
    'title': {
        'description': 'Value to show on actual button',
        'type': 'TextWdg',
        'order': 0,
        'category': 'Options'
    },
    'tip': {
        'description': 'Tool tip info to show when mouse hovers over button',
        'type': 'TextWdg',
        'order': 1,
        'category': 'Options'
    },
    'action': {
        'description': 'Javascript callback',
        'type': 'TextAreaWdg',
        'order': 1,
        'category': 'Options'
    }
    }
 
    def __init__(my, **kwargs):
        my.top = DivWdg()
        my.kwargs = kwargs
        my.text_wdg = DivWdg()
        my.table = Table()
        my.table.add_row()
        my.table.add_style("color", "#333")
        my.td = my.table.add_cell()
        super(ActionButtonWdg,my).__init__()


    def add_behavior(my, behavior):
        my.td.add_behavior(behavior)

    def add_style(my, name, value=None):
        my.top.add_style(name, value)

    def get_display(my):
        top = my.top
        top.add_class("spt_button_top")
        my.add(top)

        base = "%s/%s" % (BASE, my.top.get_theme() )

        # medium or large only
        size = my.kwargs.get("size")
        if not size:
            size = 'medium'
        size = size[:1]
        img_src = {
            'over': '%s/btn_%s_over.png' % (base, size),
            'click': '%s/btn_%s_click.png' % (base, size),
            'up': '%s/btn_%s_up.png' % (base, size),
        }

        
        if size == 'm':
            top_width = 83
            my.top.add_style("width: %spx"%top_width)
        if size == 'l':
            top_width = 127
            my.top.add_style("width: %spx"%top_width)

        top.add(my.table)
        td = my.td
        button_div = DivWdg()
        td.add(button_div)
        button_div.add_style("position: relative")
        button_div.add_style("text-align: center")
        button_div.add_style("width: 100%")


        title = my.kwargs.get("title")
        if not title:
            title = "No Title"

        img = HtmlElement.img(src=img_src.get('up'))
        button_div.add(img)
        img.add_class("spt_button_img")
        img.add_style("opacity: 1.0")
        # stretch it wider in case the text is longer, 
        # don't make it too long though
        if len(title) > 10:
            width = len(title)/8.0 * 60
            if width < top_width:
                width = top_width
            img.add_style('width', width)
            img.add_style('height', '28px')
        if not title:
            title = "(No title)"
        #title = "Search"
        tip = my.kwargs.get("tip")
        if not tip:
            tip = title
        top.add_attr("title", tip)


        title2 = my.kwargs.get("title2")
        if title2:
            td.add_behavior( {
            'type': 'click_up',
            'title1': title,
            'title2': title2,
            'cbjs_action': '''
            var label_el = bvr.src_el.getElement(".spt_label");
            var label1 = "<b>" + bvr.title1 + "</b>";
            var label2 = "<b>" + bvr.title2 + "</b>";
            if (label_el.innerHTML == label1) {
                label_el.innerHTML = label2;
            }
            else {
                label_el.innerHTML = label1;
            }
            '''
            } )


        text_div = my.text_wdg
        button_div.add(text_div)
        text_div.add_class("spt_label")
        text_div.add_style("position: absolute")
        text_div.add("<b>%s</b>" % title)
        text_div.add_style("width: 100%")
        #text_div.add_style("margin-top: -21")
        text_div.add_style("top: 6px")
        text_div.add_style("z-index: 10")
        text_div.add_attr('spt_text_label', title)
        #text_div.add_style("border: solid 1px blue")




        td.add_behavior( {
        'type': 'hover',
        'img_src': img_src,
        'cbjs_action_over': '''
            var top = bvr.src_el.getParent(".spt_button_top");
            var img = top.getElement(".spt_button_img");
            img.src = bvr.img_src.over;
        ''',
        'cbjs_action_out': '''
            var top = bvr.src_el.getParent(".spt_button_top");
            if (!top) return;
            var img = top.getElement(".spt_button_img");
            img.src = bvr.img_src.up;
        '''
        } )
        td.add_behavior( {
        'type': 'click',
        'img_src': img_src,
        'cbjs_action': '''
            var top = bvr.src_el.getParent(".spt_button_top");
            var img = top.getElement(".spt_button_img");
            img.src = bvr.img_src.click;
        '''
        } )
        td.add_behavior( {
        'type': 'click_up',
        'img_src': img_src,
        'cbjs_action': '''
            var top = bvr.src_el.getParent(".spt_button_top");
            if (!top) return;
            var img = top.getElement(".spt_button_img");
            img.src = bvr.img_src.up;
        '''
        } )

        text_div.add_class("hand")


        return super(ActionButtonWdg,my).get_display()



class IconButtonWdg(DivWdg):
    def __init__(my, **kwargs):
        my.kwargs = kwargs
        super(IconButtonWdg, my).__init__()
        my.base = "%s/%s" % (BASE, my.get_theme() )


    def get_out_img(my):
        return None

    def get_over_img(my):
        return "<img src='%s/icon_button_over_bg.png'/>" % my.base

    def get_click_img(my):
        return "<img src='%s/icon_button_click_bg.png'/>" % my.base
        
    def get_offset(my):
        return (2, 0)



    def get_display(my):
        my.add_style("position: relative")
        my.add_class("spt_button_top")
        my.add_style("height: 20px")
        my.add_style("width: 28px")
        my.add_style("margin: 0px")

        display = DivWdg()
        my.add(display)

        offset = my.get_offset()


        out_div = DivWdg()
        display.add(out_div)
        out_div.add_class("spt_button_out")
        out_img = my.get_out_img()
        out_div.add_style("left: %spx" % offset[0])
        out_div.add_style("top: %spx" % offset[1])
        if out_img:
            out_div.add(out_img)
        out_div.add_style("position: absolute")


        over_div = DivWdg()
        display.add(over_div)
        over_div.add_class("spt_button_over")
        over_img = my.get_over_img()
        over_div.add_style("left: %spx" % offset[0])
        over_div.add_style("top: %spx" % offset[1])
        over_div.add(over_img)
        over_div.add_style("position: absolute")
        over_div.add_style("display: none")


        click_div = DivWdg()
        display.add(click_div)
        click_div.add_class("spt_button_click")
        click_img = my.get_click_img()
        click_div.add_style("left: %spx" % offset[0])
        click_div.add_style("top: %spx" % offset[1])
        click_div.add(click_img)
        click_div.add_style("position: absolute")
        click_div.add_style("display: none")



        icon_str = my.kwargs.get("icon")
        title = my.kwargs.get("title")
        tip = my.kwargs.get("tip")
        if not tip:
            tip = title

        icon_div = DivWdg()
        icon_div.add_class("hand")
        icon_div.add_style("top: 3px")
        icon_div.add_style("left: 5px")
        display.add(icon_div)
        icon_div.add_style("position: absolute")

        icon = IconWdg(title, icon_str)
        icon_div.add(icon)
        if tip:
            display.add_attr("title", tip)


        my.show_arrow = my.kwargs.get("show_arrow") in [True, 'true']
        #if my.show_arrow or my.dialog:
        if my.show_arrow:
            arrow_div = DivWdg()
            icon_div.add(arrow_div)
            arrow_div.add_style("position: absolute")
            arrow_div.add_style("top: 13px")
            arrow_div.add_style("left: 11px")

            arrow = IconWdg(title, IconWdg.ARROW_MORE_INFO)
            arrow_div.add(arrow)





        hit_wdg = my

        hit_wdg.add_behavior( {
        'type': 'hover',
        'cbjs_action_over': '''
            var out = bvr.src_el.getElement(".spt_button_out");
            var over = bvr.src_el.getElement(".spt_button_over");
            var click = bvr.src_el.getElement(".spt_button_click");
            out.setStyle("display", "none");
            over.setStyle("display", "");
            click.setStyle("display", "none");
        ''',
        'cbjs_action_out': '''
            var out = bvr.src_el.getElement(".spt_button_out");
            var over = bvr.src_el.getElement(".spt_button_over");
            var click = bvr.src_el.getElement(".spt_button_click");
            out.setStyle("display", "");
            over.setStyle("display", "none");
            click.setStyle("display", "none");
        '''
        } )
        
        hit_wdg.add_behavior( {
        'type': 'click',
        'cbjs_action': '''
            var out = bvr.src_el.getElement(".spt_button_out");
            var over = bvr.src_el.getElement(".spt_button_over");
            var click = bvr.src_el.getElement(".spt_button_click");
            out.setStyle("display", "none");
            over.setStyle("display", "none");
            click.setStyle("display", "");
        '''
        } )
        hit_wdg.add_behavior( {
        'type': 'click_up',
        'cbjs_action': '''
            var out = bvr.src_el.getElement(".spt_button_out");
            var over = bvr.src_el.getElement(".spt_button_over");
            var click = bvr.src_el.getElement(".spt_button_click");
            over.setStyle("display", "");
            over.setStyle("display", "none");
            click.setStyle("display", "none");
        '''
        } )

        spacer = DivWdg()
        display.add(spacer)
        spacer.add("")


        return super(IconButtonWdg, my).get_display()


from tactic.ui.common import BaseTableElementWdg
class IconButtonElementWdg(BaseTableElementWdg):
    def get_display(my):
        return IconButtonWdg(**my.options)



class SingleButtonWdg(IconButtonWdg):

    def get_out_img(my):
        if my.kwargs.get("show_out") in [False, "false"]:
            return None
        img = "<img src='%s/Opaque_MainButton_out.png'/>" % my.base
        return img

    def get_over_img(my):
        return "<img src='%s/Opaque_MainButton_over.png'/>" % my.base

    def get_click_img(my):
        return "<img src='%s/Opaque_MainButton_click.png'/>" % my.base

    def get_offset(my):
        return (-1, -9)

